/*
 * NodeMetadataSet.cpp
 *
 * Copyright (C) 2006 J. "MUFTI" Scheurich
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "NodeMetadataSet.h"
#include "Proto.h"
#include "FieldValue.h"
#include "MFNode.h"

ProtoMetadataSet::ProtoMetadataSet(Scene *scene)
  : ProtoMetadata(scene, "MetadataSet")
{
     value.set(
          addField(MFNODE, "value", new MFNode(), METADATA_NODE));
}

Node *
ProtoMetadataSet::create(Scene *scene)
{ 
    return new NodeMetadataSet(scene, this); 
}

NodeMetadataSet::NodeMetadataSet(Scene *scene, Proto *proto)
 : Metadata(scene, proto)
{
}
