/* 
 * openglutfont.c
 * 
 * implementation of 
 *
 * glutStrokeCharacter(GLUT_STROKE_ROMAN, 
 *
 * build from the sources of the OpenGLUT library 
 */

#include "GL/gl.h"
#ifndef NULL
#define NULL 0
#endif
#include "openglutfont.h"

/*
    parts of og_internal.h

    \file  og_internal.h
    \brief The OpenGLUT library private include file.
*/
/*
 * Portions copyright (C) 2004, the OpenGLUT project contributors.
 * OpenGLUT branched from freeglut in February, 2004.
 *
 * Copyright (c) 1999-2000 Pawel W. Olszta. All Rights Reserved.
 * Written by Pawel W. Olszta, <olszta@sourceforge.net>
 * Creation date: Thu Dec 2 1999
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * PAWEL W. OLSZTA BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * The stroke font structures
 */

typedef struct tagSOG_StrokeVertex SOG_StrokeVertex;
struct tagSOG_StrokeVertex
{
    GLfloat         X, Y;
};

typedef struct tagSOG_StrokeStrip SOG_StrokeStrip;
struct tagSOG_StrokeStrip
{
    int                     Number;
    const SOG_StrokeVertex *Vertices;
};

typedef struct tagSOG_StrokeChar SOG_StrokeChar;
struct tagSOG_StrokeChar
{
    GLfloat         Right;
    int             Number;
    const SOG_StrokeStrip* Strips;
};

typedef struct tagSOG_StrokeFont SOG_StrokeFont;
struct tagSOG_StrokeFont
{
    char           *Name;                       /* The source font name      */
    int             Quantity;                   /* Number of chars in font   */
    GLfloat         Height;                     /* Height of the characters  */
    const SOG_StrokeChar **Characters;          /* The characters mapping    */
};

/* This file has been automatically generated by the genstroke utility. */

/*
    \file  og_stroke_roman.c
    \brief Stroke data for proportional-spaced roman font.
*/
/*
 * Portions copyright 2003, OpenGLUT contributors.
 * OpenGLUT branched from freeglut in February 2004.
 */
/* This file has been automatically generated by the genstroke utility. */

/* char: 0x20 */

static const SOG_StrokeStrip ch32st[] =
{
    { 0, NULL }
};

static const SOG_StrokeChar ch32 = {104.762f,0,ch32st};

/* char: 0x21 */

static const SOG_StrokeVertex ch33st0[] =
{
    {13.3819f,100.0f},
    {13.3819f,33.3333f}
};

static const SOG_StrokeVertex ch33st1[] =
{
    {13.3819f,9.5238f},
    {8.62f,4.7619f},
    {13.3819f,0.0f},
    {18.1438f,4.7619f},
    {13.3819f,9.5238f}
};

static const SOG_StrokeStrip ch33st[] =
{
    {2,ch33st0},
    {5,ch33st1}
};

static const SOG_StrokeChar ch33 = {26.6238f,2,ch33st};

/* char: 0x22 */

static const SOG_StrokeVertex ch34st0[] =
{
    {4.02f,100.0f},
    {4.02f,66.6667f}
};

static const SOG_StrokeVertex ch34st1[] =
{
    {42.1152f,100.0f},
    {42.1152f,66.6667f}
};

static const SOG_StrokeStrip ch34st[] =
{
    {2,ch34st0},
    {2,ch34st1}
};

static const SOG_StrokeChar ch34 = {51.4352f,2,ch34st};

/* char: 0x23 */

static const SOG_StrokeVertex ch35st0[] =
{
    {41.2952f,119.048f},
    {7.9619f,-33.3333f}
};

static const SOG_StrokeVertex ch35st1[] =
{
    {69.8667f,119.048f},
    {36.5333f,-33.3333f}
};

static const SOG_StrokeVertex ch35st2[] =
{
    {7.9619f,57.1429f},
    {74.6286f,57.1429f}
};

static const SOG_StrokeVertex ch35st3[] =
{
    {3.2f,28.5714f},
    {69.8667f,28.5714f}
};

static const SOG_StrokeStrip ch35st[] =
{
    {2,ch35st0},
    {2,ch35st1},
    {2,ch35st2},
    {2,ch35st3}
};

static const SOG_StrokeChar ch35 = {79.4886f,4,ch35st};

/* char: 0x24 */

static const SOG_StrokeVertex ch36st0[] =
{
    {28.6295f,119.048f},
    {28.6295f,-19.0476f}
};

static const SOG_StrokeVertex ch36st1[] =
{
    {47.6771f,119.048f},
    {47.6771f,-19.0476f}
};

static const SOG_StrokeVertex ch36st2[] =
{
    {71.4867f,85.7143f},
    {61.9629f,95.2381f},
    {47.6771f,100.0f},
    {28.6295f,100.0f},
    {14.3438f,95.2381f},
    {4.82f,85.7143f},
    {4.82f,76.1905f},
    {9.5819f,66.6667f},
    {14.3438f,61.9048f},
    {23.8676f,57.1429f},
    {52.439f,47.619f},
    {61.9629f,42.8571f},
    {66.7248f,38.0952f},
    {71.4867f,28.5714f},
    {71.4867f,14.2857f},
    {61.9629f,4.7619f},
    {47.6771f,0.0f},
    {28.6295f,0.0f},
    {14.3438f,4.7619f},
    {4.82f,14.2857f}
};

static const SOG_StrokeStrip ch36st[] =
{
    {2,ch36st0},
    {2,ch36st1},
    {20,ch36st2}
};

static const SOG_StrokeChar ch36 = {76.2067f,3,ch36st};

/* char: 0x25 */

static const SOG_StrokeVertex ch37st0[] =
{
    {92.0743f,100.0f},
    {6.36f,0.0f}
};

static const SOG_StrokeVertex ch37st1[] =
{
    {30.1695f,100.0f},
    {39.6933f,90.4762f},
    {39.6933f,80.9524f},
    {34.9314f,71.4286f},
    {25.4076f,66.6667f},
    {15.8838f,66.6667f},
    {6.36f,76.1905f},
    {6.36f,85.7143f},
    {11.1219f,95.2381f},
    {20.6457f,100.0f},
    {30.1695f,100.0f},
    {39.6933f,95.2381f},
    {53.979f,90.4762f},
    {68.2648f,90.4762f},
    {82.5505f,95.2381f},
    {92.0743f,100.0f}
};

static const SOG_StrokeVertex ch37st2[] =
{
    {73.0267f,33.3333f},
    {63.5029f,28.5714f},
    {58.741f,19.0476f},
    {58.741f,9.5238f},
    {68.2648f,0.0f},
    {77.7886f,0.0f},
    {87.3124f,4.7619f},
    {92.0743f,14.2857f},
    {92.0743f,23.8095f},
    {82.5505f,33.3333f},
    {73.0267f,33.3333f}
};

static const SOG_StrokeStrip ch37st[] =
{
    {2,ch37st0},
    {16,ch37st1},
    {11,ch37st2}
};

static const SOG_StrokeChar ch37 = {96.5743f,3,ch37st};

/* char: 0x26 */

static const SOG_StrokeVertex ch38st0[] =
{
    {101.218f,57.1429f},
    {101.218f,61.9048f},
    {96.4562f,66.6667f},
    {91.6943f,66.6667f},
    {86.9324f,61.9048f},
    {82.1705f,52.381f},
    {72.6467f,28.5714f},
    {63.1229f,14.2857f},
    {53.599f,4.7619f},
    {44.0752f,0.0f},
    {25.0276f,0.0f},
    {15.5038f,4.7619f},
    {10.7419f,9.5238f},
    {5.98f,19.0476f},
    {5.98f,28.5714f},
    {10.7419f,38.0952f},
    {15.5038f,42.8571f},
    {48.8371f,61.9048f},
    {53.599f,66.6667f},
    {58.361f,76.1905f},
    {58.361f,85.7143f},
    {53.599f,95.2381f},
    {44.0752f,100.0f},
    {34.5514f,95.2381f},
    {29.7895f,85.7143f},
    {29.7895f,76.1905f},
    {34.5514f,61.9048f},
    {44.0752f,47.619f},
    {67.8848f,14.2857f},
    {77.4086f,4.7619f},
    {86.9324f,0.0f},
    {96.4562f,0.0f},
    {101.218f,4.7619f},
    {101.218f,9.5238f}
};

static const SOG_StrokeStrip ch38st[] =
{
    {34,ch38st0}
};

static const SOG_StrokeChar ch38 = {101.758f,1,ch38st};

/* char: 0x27 */

static const SOG_StrokeVertex ch39st0[] =
{
    {4.44f,100.0f},
    {4.44f,66.6667f}
};

static const SOG_StrokeStrip ch39st[] =
{
    {2,ch39st0}
};

static const SOG_StrokeChar ch39 = {13.62f,1,ch39st};

/* char: 0x28 */

static const SOG_StrokeVertex ch40st0[] =
{
    {40.9133f,119.048f},
    {31.3895f,109.524f},
    {21.8657f,95.2381f},
    {12.3419f,76.1905f},
    {7.58f,52.381f},
    {7.58f,33.3333f},
    {12.3419f,9.5238f},
    {21.8657f,-9.5238f},
    {31.3895f,-23.8095f},
    {40.9133f,-33.3333f}
};

static const SOG_StrokeStrip ch40st[] =
{
    {10,ch40st0}
};

static const SOG_StrokeChar ch40 = {47.1733f,1,ch40st};

/* char: 0x29 */

static const SOG_StrokeVertex ch41st0[] =
{
    {5.28f,119.048f},
    {14.8038f,109.524f},
    {24.3276f,95.2381f},
    {33.8514f,76.1905f},
    {38.6133f,52.381f},
    {38.6133f,33.3333f},
    {33.8514f,9.5238f},
    {24.3276f,-9.5238f},
    {14.8038f,-23.8095f},
    {5.28f,-33.3333f}
};

static const SOG_StrokeStrip ch41st[] =
{
    {10,ch41st0}
};

static const SOG_StrokeChar ch41 = {47.5333f,1,ch41st};

/* char: 0x2a */

static const SOG_StrokeVertex ch42st0[] =
{
    {30.7695f,71.4286f},
    {30.7695f,14.2857f}
};

static const SOG_StrokeVertex ch42st1[] =
{
    {6.96f,57.1429f},
    {54.579f,28.5714f}
};

static const SOG_StrokeVertex ch42st2[] =
{
    {54.579f,57.1429f},
    {6.96f,28.5714f}
};

static const SOG_StrokeStrip ch42st[] =
{
    {2,ch42st0},
    {2,ch42st1},
    {2,ch42st2}
};

static const SOG_StrokeChar ch42 = {59.439f,3,ch42st};

/* char: 0x2b */

static const SOG_StrokeVertex ch43st0[] =
{
    {48.8371f,85.7143f},
    {48.8371f,0.0f}
};

static const SOG_StrokeVertex ch43st1[] =
{
    {5.98f,42.8571f},
    {91.6943f,42.8571f}
};

static const SOG_StrokeStrip ch43st[] =
{
    {2,ch43st0},
    {2,ch43st1}
};

static const SOG_StrokeChar ch43 = {97.2543f,2,ch43st};

/* char: 0x2c */

static const SOG_StrokeVertex ch44st0[] =
{
    {18.2838f,4.7619f},
    {13.5219f,0.0f},
    {8.76f,4.7619f},
    {13.5219f,9.5238f},
    {18.2838f,4.7619f},
    {18.2838f,-4.7619f},
    {13.5219f,-14.2857f},
    {8.76f,-19.0476f}
};

static const SOG_StrokeStrip ch44st[] =
{
    {8,ch44st0}
};

static const SOG_StrokeChar ch44 = {26.0638f,1,ch44st};

/* char: 0x2d */

static const SOG_StrokeVertex ch45st0[] =
{
    {7.38f,42.8571f},
    {93.0943f,42.8571f}
};

static const SOG_StrokeStrip ch45st[] =
{
    {2,ch45st0}
};

static const SOG_StrokeChar ch45 = {100.754f,1,ch45st};

/* char: 0x2e */

static const SOG_StrokeVertex ch46st0[] =
{
    {13.1019f,9.5238f},
    {8.34f,4.7619f},
    {13.1019f,0.0f},
    {17.8638f,4.7619f},
    {13.1019f,9.5238f}
};

static const SOG_StrokeStrip ch46st[] =
{
    {5,ch46st0}
};

static const SOG_StrokeChar ch46 = {26.4838f,1,ch46st};

/* char: 0x2f */

static const SOG_StrokeVertex ch47st0[] =
{
    {7.24f,-14.2857f},
    {73.9067f,100.0f}
};

static const SOG_StrokeStrip ch47st[] =
{
    {2,ch47st0}
};

static const SOG_StrokeChar ch47 = {82.1067f,1,ch47st};

/* char: 0x30 */

static const SOG_StrokeVertex ch48st0[] =
{
    {33.5514f,100.0f},
    {19.2657f,95.2381f},
    {9.7419f,80.9524f},
    {4.98f,57.1429f},
    {4.98f,42.8571f},
    {9.7419f,19.0476f},
    {19.2657f,4.7619f},
    {33.5514f,0.0f},
    {43.0752f,0.0f},
    {57.361f,4.7619f},
    {66.8848f,19.0476f},
    {71.6467f,42.8571f},
    {71.6467f,57.1429f},
    {66.8848f,80.9524f},
    {57.361f,95.2381f},
    {43.0752f,100.0f},
    {33.5514f,100.0f}
};

static const SOG_StrokeStrip ch48st[] =
{
    {17,ch48st0}
};

static const SOG_StrokeChar ch48 = {77.0667f,1,ch48st};

/* char: 0x31 */

static const SOG_StrokeVertex ch49st0[] =
{
    {11.82f,80.9524f},
    {21.3438f,85.7143f},
    {35.6295f,100.0f},
    {35.6295f,0.0f}
};

static const SOG_StrokeStrip ch49st[] =
{
    {4,ch49st0}
};

static const SOG_StrokeChar ch49 = {66.5295f,1,ch49st};

/* char: 0x32 */

static const SOG_StrokeVertex ch50st0[] =
{
    {10.1819f,76.1905f},
    {10.1819f,80.9524f},
    {14.9438f,90.4762f},
    {19.7057f,95.2381f},
    {29.2295f,100.0f},
    {48.2771f,100.0f},
    {57.801f,95.2381f},
    {62.5629f,90.4762f},
    {67.3248f,80.9524f},
    {67.3248f,71.4286f},
    {62.5629f,61.9048f},
    {53.039f,47.619f},
    {5.42f,0.0f},
    {72.0867f,0.0f}
};

static const SOG_StrokeStrip ch50st[] =
{
    {14,ch50st0}
};

static const SOG_StrokeChar ch50 = {77.6467f,1,ch50st};

/* char: 0x33 */

static const SOG_StrokeVertex ch51st0[] =
{
    {14.5238f,100.0f},
    {66.9048f,100.0f},
    {38.3333f,61.9048f},
    {52.619f,61.9048f},
    {62.1429f,57.1429f},
    {66.9048f,52.381f},
    {71.6667f,38.0952f},
    {71.6667f,28.5714f},
    {66.9048f,14.2857f},
    {57.381f,4.7619f},
    {43.0952f,0.0f},
    {28.8095f,0.0f},
    {14.5238f,4.7619f},
    {9.7619f,9.5238f},
    {5.0f,19.0476f}
};

static const SOG_StrokeStrip ch51st[] =
{
    {15,ch51st0}
};

static const SOG_StrokeChar ch51 = {77.0467f,1,ch51st};

/* char: 0x34 */

static const SOG_StrokeVertex ch52st0[] =
{
    {51.499f,100.0f},
    {3.88f,33.3333f},
    {75.3086f,33.3333f}
};

static const SOG_StrokeVertex ch52st1[] =
{
    {51.499f,100.0f},
    {51.499f,0.0f}
};

static const SOG_StrokeStrip ch52st[] =
{
    {3,ch52st0},
    {2,ch52st1}
};

static const SOG_StrokeChar ch52 = {80.1686f,2,ch52st};

/* char: 0x35 */

static const SOG_StrokeVertex ch53st0[] =
{
    {62.0029f,100.0f},
    {14.3838f,100.0f},
    {9.6219f,57.1429f},
    {14.3838f,61.9048f},
    {28.6695f,66.6667f},
    {42.9552f,66.6667f},
    {57.241f,61.9048f},
    {66.7648f,52.381f},
    {71.5267f,38.0952f},
    {71.5267f,28.5714f},
    {66.7648f,14.2857f},
    {57.241f,4.7619f},
    {42.9552f,0.0f},
    {28.6695f,0.0f},
    {14.3838f,4.7619f},
    {9.6219f,9.5238f},
    {4.86f,19.0476f}
};

static const SOG_StrokeStrip ch53st[] =
{
    {17,ch53st0}
};

static const SOG_StrokeChar ch53 = {77.6867f,1,ch53st};

/* char: 0x36 */

static const SOG_StrokeVertex ch54st0[] =
{
    {62.7229f,85.7143f},
    {57.961f,95.2381f},
    {43.6752f,100.0f},
    {34.1514f,100.0f},
    {19.8657f,95.2381f},
    {10.3419f,80.9524f},
    {5.58f,57.1429f},
    {5.58f,33.3333f},
    {10.3419f,14.2857f},
    {19.8657f,4.7619f},
    {34.1514f,0.0f},
    {38.9133f,0.0f},
    {53.199f,4.7619f},
    {62.7229f,14.2857f},
    {67.4848f,28.5714f},
    {67.4848f,33.3333f},
    {62.7229f,47.619f},
    {53.199f,57.1429f},
    {38.9133f,61.9048f},
    {34.1514f,61.9048f},
    {19.8657f,57.1429f},
    {10.3419f,47.619f},
    {5.58f,33.3333f}
};

static const SOG_StrokeStrip ch54st[] =
{
    {23,ch54st0}
};

static const SOG_StrokeChar ch54 = {73.8048f,1,ch54st};

/* char: 0x37 */

static const SOG_StrokeVertex ch55st0[] =
{
    {72.2267f,100.0f},
    {24.6076f,0.0f}
};

static const SOG_StrokeVertex ch55st1[] =
{
    {5.56f,100.0f},
    {72.2267f,100.0f}
};

static const SOG_StrokeStrip ch55st[] =
{
    {2,ch55st0},
    {2,ch55st1}
};

static const SOG_StrokeChar ch55 = {77.2267f,2,ch55st};

/* char: 0x38 */

static const SOG_StrokeVertex ch56st0[] =
{
    {29.4095f,100.0f},
    {15.1238f,95.2381f},
    {10.3619f,85.7143f},
    {10.3619f,76.1905f},
    {15.1238f,66.6667f},
    {24.6476f,61.9048f},
    {43.6952f,57.1429f},
    {57.981f,52.381f},
    {67.5048f,42.8571f},
    {72.2667f,33.3333f},
    {72.2667f,19.0476f},
    {67.5048f,9.5238f},
    {62.7429f,4.7619f},
    {48.4571f,0.0f},
    {29.4095f,0.0f},
    {15.1238f,4.7619f},
    {10.3619f,9.5238f},
    {5.6f,19.0476f},
    {5.6f,33.3333f},
    {10.3619f,42.8571f},
    {19.8857f,52.381f},
    {34.1714f,57.1429f},
    {53.219f,61.9048f},
    {62.7429f,66.6667f},
    {67.5048f,76.1905f},
    {67.5048f,85.7143f},
    {62.7429f,95.2381f},
    {48.4571f,100.0f},
    {29.4095f,100.0f}
};

static const SOG_StrokeStrip ch56st[] =
{
    {29,ch56st0}
};

static const SOG_StrokeChar ch56 = {77.6667f,1,ch56st};

/* char: 0x39 */

static const SOG_StrokeVertex ch57st0[] =
{
    {68.5048f,66.6667f},
    {63.7429f,52.381f},
    {54.219f,42.8571f},
    {39.9333f,38.0952f},
    {35.1714f,38.0952f},
    {20.8857f,42.8571f},
    {11.3619f,52.381f},
    {6.6f,66.6667f},
    {6.6f,71.4286f},
    {11.3619f,85.7143f},
    {20.8857f,95.2381f},
    {35.1714f,100.0f},
    {39.9333f,100.0f},
    {54.219f,95.2381f},
    {63.7429f,85.7143f},
    {68.5048f,66.6667f},
    {68.5048f,42.8571f},
    {63.7429f,19.0476f},
    {54.219f,4.7619f},
    {39.9333f,0.0f},
    {30.4095f,0.0f},
    {16.1238f,4.7619f},
    {11.3619f,14.2857f}
};

static const SOG_StrokeStrip ch57st[] =
{
    {23,ch57st0}
};

static const SOG_StrokeChar ch57 = {74.0648f,1,ch57st};

/* char: 0x3a */

static const SOG_StrokeVertex ch58st0[] =
{
    {14.0819f,66.6667f},
    {9.32f,61.9048f},
    {14.0819f,57.1429f},
    {18.8438f,61.9048f},
    {14.0819f,66.6667f}
};

static const SOG_StrokeVertex ch58st1[] =
{
    {14.0819f,9.5238f},
    {9.32f,4.7619f},
    {14.0819f,0.0f},
    {18.8438f,4.7619f},
    {14.0819f,9.5238f}
};

static const SOG_StrokeStrip ch58st[] =
{
    {5,ch58st0},
    {5,ch58st1}
};

static const SOG_StrokeChar ch58 = {26.2238f,2,ch58st};

/* char: 0x3b */

static const SOG_StrokeVertex ch59st0[] =
{
    {12.9619f,66.6667f},
    {8.2f,61.9048f},
    {12.9619f,57.1429f},
    {17.7238f,61.9048f},
    {12.9619f,66.6667f}
};

static const SOG_StrokeVertex ch59st1[] =
{
    {17.7238f,4.7619f},
    {12.9619f,0.0f},
    {8.2f,4.7619f},
    {12.9619f,9.5238f},
    {17.7238f,4.7619f},
    {17.7238f,-4.7619f},
    {12.9619f,-14.2857f},
    {8.2f,-19.0476f}
};

static const SOG_StrokeStrip ch59st[] =
{
    {5,ch59st0},
    {8,ch59st1}
};

static const SOG_StrokeChar ch59 = {26.3038f,2,ch59st};

/* char: 0x3c */

static const SOG_StrokeVertex ch60st0[] =
{
    {79.2505f,85.7143f},
    {3.06f,42.8571f},
    {79.2505f,0.0f}
};

static const SOG_StrokeStrip ch60st[] =
{
    {3,ch60st0}
};

static const SOG_StrokeChar ch60 = {81.6105f,1,ch60st};

/* char: 0x3d */

static const SOG_StrokeVertex ch61st0[] =
{
    {5.7f,57.1429f},
    {91.4143f,57.1429f}
};

static const SOG_StrokeVertex ch61st1[] =
{
    {5.7f,28.5714f},
    {91.4143f,28.5714f}
};

static const SOG_StrokeStrip ch61st[] =
{
    {2,ch61st0},
    {2,ch61st1}
};

static const SOG_StrokeChar ch61 = {97.2543f,2,ch61st};

/* char: 0x3e */

static const SOG_StrokeVertex ch62st0[] =
{
    {2.78f,85.7143f},
    {78.9705f,42.8571f},
    {2.78f,0.0f}
};

static const SOG_StrokeStrip ch62st[] =
{
    {3,ch62st0}
};

static const SOG_StrokeChar ch62 = {81.6105f,1,ch62st};

/* char: 0x3f */

static const SOG_StrokeVertex ch63st0[] =
{
    {8.42f,76.1905f},
    {8.42f,80.9524f},
    {13.1819f,90.4762f},
    {17.9438f,95.2381f},
    {27.4676f,100.0f},
    {46.5152f,100.0f},
    {56.039f,95.2381f},
    {60.801f,90.4762f},
    {65.5629f,80.9524f},
    {65.5629f,71.4286f},
    {60.801f,61.9048f},
    {56.039f,57.1429f},
    {36.9914f,47.619f},
    {36.9914f,33.3333f}
};

static const SOG_StrokeVertex ch63st1[] =
{
    {36.9914f,9.5238f},
    {32.2295f,4.7619f},
    {36.9914f,0.0f},
    {41.7533f,4.7619f},
    {36.9914f,9.5238f}
};

static const SOG_StrokeStrip ch63st[] =
{
    {14,ch63st0},
    {5,ch63st1}
};

static const SOG_StrokeChar ch63 = {73.9029f,2,ch63st};

/* char: 0x40 */

static const SOG_StrokeVertex ch64st0[] =
{
    {49.2171f,52.381f},
    {39.6933f,57.1429f},
    {30.1695f,57.1429f},
    {25.4076f,47.619f},
    {25.4076f,42.8571f},
    {30.1695f,33.3333f},
    {39.6933f,33.3333f},
    {49.2171f,38.0952f}
};

static const SOG_StrokeVertex ch64st1[] =
{
    {49.2171f,57.1429f},
    {49.2171f,38.0952f},
    {53.979f,33.3333f},
    {63.5029f,33.3333f},
    {68.2648f,42.8571f},
    {68.2648f,47.619f},
    {63.5029f,61.9048f},
    {53.979f,71.4286f},
    {39.6933f,76.1905f},
    {34.9314f,76.1905f},
    {20.6457f,71.4286f},
    {11.1219f,61.9048f},
    {6.36f,47.619f},
    {6.36f,42.8571f},
    {11.1219f,28.5714f},
    {20.6457f,19.0476f},
    {34.9314f,14.2857f},
    {39.6933f,14.2857f},
    {53.979f,19.0476f}
};

static const SOG_StrokeStrip ch64st[] =
{
    {8,ch64st0},
    {19,ch64st1}
};

static const SOG_StrokeChar ch64 = {74.3648f,2,ch64st};

/* char: 0x41 */

static const SOG_StrokeVertex ch65st0[] =
{
    {40.5952f,100.0f},
    {2.5f,0.0f}
};

static const SOG_StrokeVertex ch65st1[] =
{
    {40.5952f,100.0f},
    {78.6905f,0.0f}
};

static const SOG_StrokeVertex ch65st2[] =
{
    {16.7857f,33.3333f},
    {64.4048f,33.3333f}
};

static const SOG_StrokeStrip ch65st[] =
{
    {2,ch65st0},
    {2,ch65st1},
    {2,ch65st2}
};

static const SOG_StrokeChar ch65 = {80.4905f,3,ch65st};

/* char: 0x42 */

static const SOG_StrokeVertex ch66st0[] =
{
    {11.42f,100.0f},
    {11.42f,0.0f}
};

static const SOG_StrokeVertex ch66st1[] =
{
    {11.42f,100.0f},
    {54.2771f,100.0f},
    {68.5629f,95.2381f},
    {73.3248f,90.4762f},
    {78.0867f,80.9524f},
    {78.0867f,71.4286f},
    {73.3248f,61.9048f},
    {68.5629f,57.1429f},
    {54.2771f,52.381f}
};

static const SOG_StrokeVertex ch66st2[] =
{
    {11.42f,52.381f},
    {54.2771f,52.381f},
    {68.5629f,47.619f},
    {73.3248f,42.8571f},
    {78.0867f,33.3333f},
    {78.0867f,19.0476f},
    {73.3248f,9.5238f},
    {68.5629f,4.7619f},
    {54.2771f,0.0f},
    {11.42f,0.0f}
};

static const SOG_StrokeStrip ch66st[] =
{
    {2,ch66st0},
    {9,ch66st1},
    {10,ch66st2}
};

static const SOG_StrokeChar ch66 = {83.6267f,3,ch66st};

/* char: 0x43 */

static const SOG_StrokeVertex ch67st0[] =
{
    {78.0886f,76.1905f},
    {73.3267f,85.7143f},
    {63.8029f,95.2381f},
    {54.279f,100.0f},
    {35.2314f,100.0f},
    {25.7076f,95.2381f},
    {16.1838f,85.7143f},
    {11.4219f,76.1905f},
    {6.66f,61.9048f},
    {6.66f,38.0952f},
    {11.4219f,23.8095f},
    {16.1838f,14.2857f},
    {25.7076f,4.7619f},
    {35.2314f,0.0f},
    {54.279f,0.0f},
    {63.8029f,4.7619f},
    {73.3267f,14.2857f},
    {78.0886f,23.8095f}
};

static const SOG_StrokeStrip ch67st[] =
{
    {18,ch67st0}
};

static const SOG_StrokeChar ch67 = {84.4886f,1,ch67st};

/* char: 0x44 */

static const SOG_StrokeVertex ch68st0[] =
{
    {11.96f,100.0f},
    {11.96f,0.0f}
};

static const SOG_StrokeVertex ch68st1[] =
{
    {11.96f,100.0f},
    {45.2933f,100.0f},
    {59.579f,95.2381f},
    {69.1029f,85.7143f},
    {73.8648f,76.1905f},
    {78.6267f,61.9048f},
    {78.6267f,38.0952f},
    {73.8648f,23.8095f},
    {69.1029f,14.2857f},
    {59.579f,4.7619f},
    {45.2933f,0.0f},
    {11.96f,0.0f}
};

static const SOG_StrokeStrip ch68st[] =
{
    {2,ch68st0},
    {12,ch68st1}
};

static const SOG_StrokeChar ch68 = {85.2867f,2,ch68st};

/* char: 0x45 */

static const SOG_StrokeVertex ch69st0[] =
{
    {11.42f,100.0f},
    {11.42f,0.0f}
};

static const SOG_StrokeVertex ch69st1[] =
{
    {11.42f,100.0f},
    {73.3248f,100.0f}
};

static const SOG_StrokeVertex ch69st2[] =
{
    {11.42f,52.381f},
    {49.5152f,52.381f}
};

static const SOG_StrokeVertex ch69st3[] =
{
    {11.42f,0.0f},
    {73.3248f,0.0f}
};

static const SOG_StrokeStrip ch69st[] =
{
    {2,ch69st0},
    {2,ch69st1},
    {2,ch69st2},
    {2,ch69st3}
};

static const SOG_StrokeChar ch69 = {78.1848f,4,ch69st};

/* char: 0x46 */

static const SOG_StrokeVertex ch70st0[] =
{
    {11.42f,100.0f},
    {11.42f,0.0f}
};

static const SOG_StrokeVertex ch70st1[] =
{
    {11.42f,100.0f},
    {73.3248f,100.0f}
};

static const SOG_StrokeVertex ch70st2[] =
{
    {11.42f,52.381f},
    {49.5152f,52.381f}
};

static const SOG_StrokeStrip ch70st[] =
{
    {2,ch70st0},
    {2,ch70st1},
    {2,ch70st2}
};

static const SOG_StrokeChar ch70 = {78.7448f,3,ch70st};

/* char: 0x47 */

static const SOG_StrokeVertex ch71st0[] =
{
    {78.4886f,76.1905f},
    {73.7267f,85.7143f},
    {64.2029f,95.2381f},
    {54.679f,100.0f},
    {35.6314f,100.0f},
    {26.1076f,95.2381f},
    {16.5838f,85.7143f},
    {11.8219f,76.1905f},
    {7.06f,61.9048f},
    {7.06f,38.0952f},
    {11.8219f,23.8095f},
    {16.5838f,14.2857f},
    {26.1076f,4.7619f},
    {35.6314f,0.0f},
    {54.679f,0.0f},
    {64.2029f,4.7619f},
    {73.7267f,14.2857f},
    {78.4886f,23.8095f},
    {78.4886f,38.0952f}
};

static const SOG_StrokeVertex ch71st1[] =
{
    {54.679f,38.0952f},
    {78.4886f,38.0952f}
};

static const SOG_StrokeStrip ch71st[] =
{
    {19,ch71st0},
    {2,ch71st1}
};

static const SOG_StrokeChar ch71 = {89.7686f,2,ch71st};

/* char: 0x48 */

static const SOG_StrokeVertex ch72st0[] =
{
    {11.42f,100.0f},
    {11.42f,0.0f}
};

static const SOG_StrokeVertex ch72st1[] =
{
    {78.0867f,100.0f},
    {78.0867f,0.0f}
};

static const SOG_StrokeVertex ch72st2[] =
{
    {11.42f,52.381f},
    {78.0867f,52.381f}
};

static const SOG_StrokeStrip ch72st[] =
{
    {2,ch72st0},
    {2,ch72st1},
    {2,ch72st2}
};

static const SOG_StrokeChar ch72 = {89.0867f,3,ch72st};

/* char: 0x49 */

static const SOG_StrokeVertex ch73st0[] =
{
    {10.86f,100.0f},
    {10.86f,0.0f}
};

static const SOG_StrokeStrip ch73st[] =
{
    {2,ch73st0}
};

static const SOG_StrokeChar ch73 = {21.3f,1,ch73st};

/* char: 0x4a */

static const SOG_StrokeVertex ch74st0[] =
{
    {50.119f,100.0f},
    {50.119f,23.8095f},
    {45.3571f,9.5238f},
    {40.5952f,4.7619f},
    {31.0714f,0.0f},
    {21.5476f,0.0f},
    {12.0238f,4.7619f},
    {7.2619f,9.5238f},
    {2.5f,23.8095f},
    {2.5f,33.3333f}
};

static const SOG_StrokeStrip ch74st[] =
{
    {10,ch74st0}
};

static const SOG_StrokeChar ch74 = {59.999f,1,ch74st};

/* char: 0x4b */

static const SOG_StrokeVertex ch75st0[] =
{
    {11.28f,100.0f},
    {11.28f,0.0f}
};

static const SOG_StrokeVertex ch75st1[] =
{
    {77.9467f,100.0f},
    {11.28f,33.3333f}
};

static const SOG_StrokeVertex ch75st2[] =
{
    {35.0895f,57.1429f},
    {77.9467f,0.0f}
};

static const SOG_StrokeStrip ch75st[] =
{
    {2,ch75st0},
    {2,ch75st1},
    {2,ch75st2}
};

static const SOG_StrokeChar ch75 = {79.3267f,3,ch75st};

/* char: 0x4c */

static const SOG_StrokeVertex ch76st0[] =
{
    {11.68f,100.0f},
    {11.68f,0.0f}
};

static const SOG_StrokeVertex ch76st1[] =
{
    {11.68f,0.0f},
    {68.8229f,0.0f}
};

static const SOG_StrokeStrip ch76st[] =
{
    {2,ch76st0},
    {2,ch76st1}
};

static const SOG_StrokeChar ch76 = {71.3229f,2,ch76st};

/* char: 0x4d */

static const SOG_StrokeVertex ch77st0[] =
{
    {10.86f,100.0f},
    {10.86f,0.0f}
};

static const SOG_StrokeVertex ch77st1[] =
{
    {10.86f,100.0f},
    {48.9552f,0.0f}
};

static const SOG_StrokeVertex ch77st2[] =
{
    {87.0505f,100.0f},
    {48.9552f,0.0f}
};

static const SOG_StrokeVertex ch77st3[] =
{
    {87.0505f,100.0f},
    {87.0505f,0.0f}
};

static const SOG_StrokeStrip ch77st[] =
{
    {2,ch77st0},
    {2,ch77st1},
    {2,ch77st2},
    {2,ch77st3}
};

static const SOG_StrokeChar ch77 = {97.2105f,4,ch77st};

/* char: 0x4e */

static const SOG_StrokeVertex ch78st0[] =
{
    {11.14f,100.0f},
    {11.14f,0.0f}
};

static const SOG_StrokeVertex ch78st1[] =
{
    {11.14f,100.0f},
    {77.8067f,0.0f}
};

static const SOG_StrokeVertex ch78st2[] =
{
    {77.8067f,100.0f},
    {77.8067f,0.0f}
};

static const SOG_StrokeStrip ch78st[] =
{
    {2,ch78st0},
    {2,ch78st1},
    {2,ch78st2}
};

static const SOG_StrokeChar ch78 = {88.8067f,3,ch78st};

/* char: 0x4f */

static const SOG_StrokeVertex ch79st0[] =
{
    {34.8114f,100.0f},
    {25.2876f,95.2381f},
    {15.7638f,85.7143f},
    {11.0019f,76.1905f},
    {6.24f,61.9048f},
    {6.24f,38.0952f},
    {11.0019f,23.8095f},
    {15.7638f,14.2857f},
    {25.2876f,4.7619f},
    {34.8114f,0.0f},
    {53.859f,0.0f},
    {63.3829f,4.7619f},
    {72.9067f,14.2857f},
    {77.6686f,23.8095f},
    {82.4305f,38.0952f},
    {82.4305f,61.9048f},
    {77.6686f,76.1905f},
    {72.9067f,85.7143f},
    {63.3829f,95.2381f},
    {53.859f,100.0f},
    {34.8114f,100.0f}
};

static const SOG_StrokeStrip ch79st[] =
{
    {21,ch79st0}
};

static const SOG_StrokeChar ch79 = {88.8305f,1,ch79st};

/* char: 0x50 */

static const SOG_StrokeVertex ch80st0[] =
{
    {12.1f,100.0f},
    {12.1f,0.0f}
};

static const SOG_StrokeVertex ch80st1[] =
{
    {12.1f,100.0f},
    {54.9571f,100.0f},
    {69.2429f,95.2381f},
    {74.0048f,90.4762f},
    {78.7667f,80.9524f},
    {78.7667f,66.6667f},
    {74.0048f,57.1429f},
    {69.2429f,52.381f},
    {54.9571f,47.619f},
    {12.1f,47.619f}
};

static const SOG_StrokeStrip ch80st[] =
{
    {2,ch80st0},
    {10,ch80st1}
};

static const SOG_StrokeChar ch80 = {85.6667f,2,ch80st};

/* char: 0x51 */

static const SOG_StrokeVertex ch81st0[] =
{
    {33.8714f,100.0f},
    {24.3476f,95.2381f},
    {14.8238f,85.7143f},
    {10.0619f,76.1905f},
    {5.3f,61.9048f},
    {5.3f,38.0952f},
    {10.0619f,23.8095f},
    {14.8238f,14.2857f},
    {24.3476f,4.7619f},
    {33.8714f,0.0f},
    {52.919f,0.0f},
    {62.4429f,4.7619f},
    {71.9667f,14.2857f},
    {76.7286f,23.8095f},
    {81.4905f,38.0952f},
    {81.4905f,61.9048f},
    {76.7286f,76.1905f},
    {71.9667f,85.7143f},
    {62.4429f,95.2381f},
    {52.919f,100.0f},
    {33.8714f,100.0f}
};

static const SOG_StrokeVertex ch81st1[] =
{
    {48.1571f,19.0476f},
    {76.7286f,-9.5238f}
};

static const SOG_StrokeStrip ch81st[] =
{
    {21,ch81st0},
    {2,ch81st1}
};

static const SOG_StrokeChar ch81 = {88.0905f,2,ch81st};

/* char: 0x52 */

static const SOG_StrokeVertex ch82st0[] =
{
    {11.68f,100.0f},
    {11.68f,0.0f}
};

static const SOG_StrokeVertex ch82st1[] =
{
    {11.68f,100.0f},
    {54.5371f,100.0f},
    {68.8229f,95.2381f},
    {73.5848f,90.4762f},
    {78.3467f,80.9524f},
    {78.3467f,71.4286f},
    {73.5848f,61.9048f},
    {68.8229f,57.1429f},
    {54.5371f,52.381f},
    {11.68f,52.381f}
};

static const SOG_StrokeVertex ch82st2[] =
{
    {45.0133f,52.381f},
    {78.3467f,0.0f}
};

static const SOG_StrokeStrip ch82st[] =
{
    {2,ch82st0},
    {10,ch82st1},
    {2,ch82st2}
};

static const SOG_StrokeChar ch82 = {82.3667f,3,ch82st};

/* char: 0x53 */

static const SOG_StrokeVertex ch83st0[] =
{
    {74.6667f,85.7143f},
    {65.1429f,95.2381f},
    {50.8571f,100.0f},
    {31.8095f,100.0f},
    {17.5238f,95.2381f},
    {8.0f,85.7143f},
    {8.0f,76.1905f},
    {12.7619f,66.6667f},
    {17.5238f,61.9048f},
    {27.0476f,57.1429f},
    {55.619f,47.619f},
    {65.1429f,42.8571f},
    {69.9048f,38.0952f},
    {74.6667f,28.5714f},
    {74.6667f,14.2857f},
    {65.1429f,4.7619f},
    {50.8571f,0.0f},
    {31.8095f,0.0f},
    {17.5238f,4.7619f},
    {8.0f,14.2857f}
};

static const SOG_StrokeStrip ch83st[] =
{
    {20,ch83st0}
};

static const SOG_StrokeChar ch83 = {80.8267f,1,ch83st};

/* char: 0x54 */

static const SOG_StrokeVertex ch84st0[] =
{
    {35.6933f,100.0f},
    {35.6933f,0.0f}
};

static const SOG_StrokeVertex ch84st1[] =
{
    {2.36f,100.0f},
    {69.0267f,100.0f}
};

static const SOG_StrokeStrip ch84st[] =
{
    {2,ch84st0},
    {2,ch84st1}
};

static const SOG_StrokeChar ch84 = {71.9467f,2,ch84st};

/* char: 0x55 */

static const SOG_StrokeVertex ch85st0[] =
{
    {11.54f,100.0f},
    {11.54f,28.5714f},
    {16.3019f,14.2857f},
    {25.8257f,4.7619f},
    {40.1114f,0.0f},
    {49.6352f,0.0f},
    {63.921f,4.7619f},
    {73.4448f,14.2857f},
    {78.2067f,28.5714f},
    {78.2067f,100.0f}
};

static const SOG_StrokeStrip ch85st[] =
{
    {10,ch85st0}
};

static const SOG_StrokeChar ch85 = {89.4867f,1,ch85st};

/* char: 0x56 */

static const SOG_StrokeVertex ch86st0[] =
{
    {2.36f,100.0f},
    {40.4552f,0.0f}
};

static const SOG_StrokeVertex ch86st1[] =
{
    {78.5505f,100.0f},
    {40.4552f,0.0f}
};

static const SOG_StrokeStrip ch86st[] =
{
    {2,ch86st0},
    {2,ch86st1}
};

static const SOG_StrokeChar ch86 = {81.6105f,2,ch86st};

/* char: 0x57 */

static const SOG_StrokeVertex ch87st0[] =
{
    {2.22f,100.0f},
    {26.0295f,0.0f}
};

static const SOG_StrokeVertex ch87st1[] =
{
    {49.839f,100.0f},
    {26.0295f,0.0f}
};

static const SOG_StrokeVertex ch87st2[] =
{
    {49.839f,100.0f},
    {73.6486f,0.0f}
};

static const SOG_StrokeVertex ch87st3[] =
{
    {97.4581f,100.0f},
    {73.6486f,0.0f}
};

static const SOG_StrokeStrip ch87st[] =
{
    {2,ch87st0},
    {2,ch87st1},
    {2,ch87st2},
    {2,ch87st3}
};

static const SOG_StrokeChar ch87 = {100.518f,4,ch87st};

/* char: 0x58 */

static const SOG_StrokeVertex ch88st0[] =
{
    {2.5f,100.0f},
    {69.1667f,0.0f}
};

static const SOG_StrokeVertex ch88st1[] =
{
    {69.1667f,100.0f},
    {2.5f,0.0f}
};

static const SOG_StrokeStrip ch88st[] =
{
    {2,ch88st0},
    {2,ch88st1}
};

static const SOG_StrokeChar ch88 = {72.3667f,2,ch88st};

/* char: 0x59 */

static const SOG_StrokeVertex ch89st0[] =
{
    {1.52f,100.0f},
    {39.6152f,52.381f},
    {39.6152f,0.0f}
};

static const SOG_StrokeVertex ch89st1[] =
{
    {77.7105f,100.0f},
    {39.6152f,52.381f}
};

static const SOG_StrokeStrip ch89st[] =
{
    {3,ch89st0},
    {2,ch89st1}
};

static const SOG_StrokeChar ch89 = {79.6505f,2,ch89st};

/* char: 0x5a */

static const SOG_StrokeVertex ch90st0[] =
{
    {69.1667f,100.0f},
    {2.5f,0.0f}
};

static const SOG_StrokeVertex ch90st1[] =
{
    {2.5f,100.0f},
    {69.1667f,100.0f}
};

static const SOG_StrokeVertex ch90st2[] =
{
    {2.5f,0.0f},
    {69.1667f,0.0f}
};

static const SOG_StrokeStrip ch90st[] =
{
    {2,ch90st0},
    {2,ch90st1},
    {2,ch90st2}
};

static const SOG_StrokeChar ch90 = {73.7467f,3,ch90st};

/* char: 0x5b */

static const SOG_StrokeVertex ch91st0[] =
{
    {7.78f,119.048f},
    {7.78f,-33.3333f}
};

static const SOG_StrokeVertex ch91st1[] =
{
    {12.5419f,119.048f},
    {12.5419f,-33.3333f}
};

static const SOG_StrokeVertex ch91st2[] =
{
    {7.78f,119.048f},
    {41.1133f,119.048f}
};

static const SOG_StrokeVertex ch91st3[] =
{
    {7.78f,-33.3333f},
    {41.1133f,-33.3333f}
};

static const SOG_StrokeStrip ch91st[] =
{
    {2,ch91st0},
    {2,ch91st1},
    {2,ch91st2},
    {2,ch91st3}
};

static const SOG_StrokeChar ch91 = {46.1133f,4,ch91st};

/* char: 0x5c */

static const SOG_StrokeVertex ch92st0[] =
{
    {5.84f,100.0f},
    {72.5067f,-14.2857f}
};

static const SOG_StrokeStrip ch92st[] =
{
    {2,ch92st0}
};

static const SOG_StrokeChar ch92 = {78.2067f,1,ch92st};

/* char: 0x5d */

static const SOG_StrokeVertex ch93st0[] =
{
    {33.0114f,119.048f},
    {33.0114f,-33.3333f}
};

static const SOG_StrokeVertex ch93st1[] =
{
    {37.7733f,119.048f},
    {37.7733f,-33.3333f}
};

static const SOG_StrokeVertex ch93st2[] =
{
    {4.44f,119.048f},
    {37.7733f,119.048f}
};

static const SOG_StrokeVertex ch93st3[] =
{
    {4.44f,-33.3333f},
    {37.7733f,-33.3333f}
};

static const SOG_StrokeStrip ch93st[] =
{
    {2,ch93st0},
    {2,ch93st1},
    {2,ch93st2},
    {2,ch93st3}
};

static const SOG_StrokeChar ch93 = {46.3933f,4,ch93st};

/* char: 0x5e */

static const SOG_StrokeVertex ch94st0[] =
{
    {44.0752f,109.524f},
    {5.98f,42.8571f}
};

static const SOG_StrokeVertex ch94st1[] =
{
    {44.0752f,109.524f},
    {82.1705f,42.8571f}
};

static const SOG_StrokeStrip ch94st[] =
{
    {2,ch94st0},
    {2,ch94st1}
};

static const SOG_StrokeChar ch94 = {90.2305f,2,ch94st};

/* char: 0x5f */

static const SOG_StrokeVertex ch95st0[] =
{
    {-1.1f,-33.3333f},
    {103.662f,-33.3333f},
    {103.662f,-28.5714f},
    {-1.1f,-28.5714f},
    {-1.1f,-33.3333f}
};

static const SOG_StrokeStrip ch95st[] =
{
    {5,ch95st0}
};

static const SOG_StrokeChar ch95 = {104.062f,1,ch95st};

/* char: 0x60 */

static const SOG_StrokeVertex ch96st0[] =
{
    {33.0219f,100.0f},
    {56.8314f,71.4286f}
};

static const SOG_StrokeVertex ch96st1[] =
{
    {33.0219f,100.0f},
    {28.26f,95.2381f},
    {56.8314f,71.4286f}
};

static const SOG_StrokeStrip ch96st[] =
{
    {2,ch96st0},
    {3,ch96st1}
};

static const SOG_StrokeChar ch96 = {83.5714f,2,ch96st};

/* char: 0x61 */

static const SOG_StrokeVertex ch97st0[] =
{
    {63.8229f,66.6667f},
    {63.8229f,0.0f}
};

static const SOG_StrokeVertex ch97st1[] =
{
    {63.8229f,52.381f},
    {54.299f,61.9048f},
    {44.7752f,66.6667f},
    {30.4895f,66.6667f},
    {20.9657f,61.9048f},
    {11.4419f,52.381f},
    {6.68f,38.0952f},
    {6.68f,28.5714f},
    {11.4419f,14.2857f},
    {20.9657f,4.7619f},
    {30.4895f,0.0f},
    {44.7752f,0.0f},
    {54.299f,4.7619f},
    {63.8229f,14.2857f}
};

static const SOG_StrokeStrip ch97st[] =
{
    {2,ch97st0},
    {14,ch97st1}
};

static const SOG_StrokeChar ch97 = {66.6029f,2,ch97st};

/* char: 0x62 */

static const SOG_StrokeVertex ch98st0[] =
{
    {8.76f,100.0f},
    {8.76f,0.0f}
};

static const SOG_StrokeVertex ch98st1[] =
{
    {8.76f,52.381f},
    {18.2838f,61.9048f},
    {27.8076f,66.6667f},
    {42.0933f,66.6667f},
    {51.6171f,61.9048f},
    {61.141f,52.381f},
    {65.9029f,38.0952f},
    {65.9029f,28.5714f},
    {61.141f,14.2857f},
    {51.6171f,4.7619f},
    {42.0933f,0.0f},
    {27.8076f,0.0f},
    {18.2838f,4.7619f},
    {8.76f,14.2857f}
};

static const SOG_StrokeStrip ch98st[] =
{
    {2,ch98st0},
    {14,ch98st1}
};

static const SOG_StrokeChar ch98 = {70.4629f,2,ch98st};

/* char: 0x63 */

static const SOG_StrokeVertex ch99st0[] =
{
    {62.6629f,52.381f},
    {53.139f,61.9048f},
    {43.6152f,66.6667f},
    {29.3295f,66.6667f},
    {19.8057f,61.9048f},
    {10.2819f,52.381f},
    {5.52f,38.0952f},
    {5.52f,28.5714f},
    {10.2819f,14.2857f},
    {19.8057f,4.7619f},
    {29.3295f,0.0f},
    {43.6152f,0.0f},
    {53.139f,4.7619f},
    {62.6629f,14.2857f}
};

static const SOG_StrokeStrip ch99st[] =
{
    {14,ch99st0}
};

static const SOG_StrokeChar ch99 = {68.9229f,1,ch99st};

/* char: 0x64 */

static const SOG_StrokeVertex ch100st0[] =
{
    {61.7829f,100.0f},
    {61.7829f,0.0f}
};

static const SOG_StrokeVertex ch100st1[] =
{
    {61.7829f,52.381f},
    {52.259f,61.9048f},
    {42.7352f,66.6667f},
    {28.4495f,66.6667f},
    {18.9257f,61.9048f},
    {9.4019f,52.381f},
    {4.64f,38.0952f},
    {4.64f,28.5714f},
    {9.4019f,14.2857f},
    {18.9257f,4.7619f},
    {28.4495f,0.0f},
    {42.7352f,0.0f},
    {52.259f,4.7619f},
    {61.7829f,14.2857f}
};

static const SOG_StrokeStrip ch100st[] =
{
    {2,ch100st0},
    {14,ch100st1}
};

static const SOG_StrokeChar ch100 = {70.2629f,2,ch100st};

/* char: 0x65 */

static const SOG_StrokeVertex ch101st0[] =
{
    {5.72f,38.0952f},
    {62.8629f,38.0952f},
    {62.8629f,47.619f},
    {58.101f,57.1429f},
    {53.339f,61.9048f},
    {43.8152f,66.6667f},
    {29.5295f,66.6667f},
    {20.0057f,61.9048f},
    {10.4819f,52.381f},
    {5.72f,38.0952f},
    {5.72f,28.5714f},
    {10.4819f,14.2857f},
    {20.0057f,4.7619f},
    {29.5295f,0.0f},
    {43.8152f,0.0f},
    {53.339f,4.7619f},
    {62.8629f,14.2857f}
};

static const SOG_StrokeStrip ch101st[] =
{
    {17,ch101st0}
};

static const SOG_StrokeChar ch101 = {68.5229f,1,ch101st};

/* char: 0x66 */

static const SOG_StrokeVertex ch102st0[] =
{
    {38.7752f,100.0f},
    {29.2514f,100.0f},
    {19.7276f,95.2381f},
    {14.9657f,80.9524f},
    {14.9657f,0.0f}
};

static const SOG_StrokeVertex ch102st1[] =
{
    {0.68f,66.6667f},
    {34.0133f,66.6667f}
};

static const SOG_StrokeStrip ch102st[] =
{
    {5,ch102st0},
    {2,ch102st1}
};

static const SOG_StrokeChar ch102 = {38.6552f,2,ch102st};

/* char: 0x67 */

static const SOG_StrokeVertex ch103st0[] =
{
    {62.5029f,66.6667f},
    {62.5029f,-9.5238f},
    {57.741f,-23.8095f},
    {52.979f,-28.5714f},
    {43.4552f,-33.3333f},
    {29.1695f,-33.3333f},
    {19.6457f,-28.5714f}
};

static const SOG_StrokeVertex ch103st1[] =
{
    {62.5029f,52.381f},
    {52.979f,61.9048f},
    {43.4552f,66.6667f},
    {29.1695f,66.6667f},
    {19.6457f,61.9048f},
    {10.1219f,52.381f},
    {5.36f,38.0952f},
    {5.36f,28.5714f},
    {10.1219f,14.2857f},
    {19.6457f,4.7619f},
    {29.1695f,0.0f},
    {43.4552f,0.0f},
    {52.979f,4.7619f},
    {62.5029f,14.2857f}
};

static const SOG_StrokeStrip ch103st[] =
{
    {7,ch103st0},
    {14,ch103st1}
};

static const SOG_StrokeChar ch103 = {70.9829f,2,ch103st};

/* char: 0x68 */

static const SOG_StrokeVertex ch104st0[] =
{
    {9.6f,100.0f},
    {9.6f,0.0f}
};

static const SOG_StrokeVertex ch104st1[] =
{
    {9.6f,47.619f},
    {23.8857f,61.9048f},
    {33.4095f,66.6667f},
    {47.6952f,66.6667f},
    {57.219f,61.9048f},
    {61.981f,47.619f},
    {61.981f,0.0f}
};

static const SOG_StrokeStrip ch104st[] =
{
    {2,ch104st0},
    {7,ch104st1}
};

static const SOG_StrokeChar ch104 = {71.021f,2,ch104st};

/* char: 0x69 */

static const SOG_StrokeVertex ch105st0[] =
{
    {10.02f,100.0f},
    {14.7819f,95.2381f},
    {19.5438f,100.0f},
    {14.7819f,104.762f},
    {10.02f,100.0f}
};

static const SOG_StrokeVertex ch105st1[] =
{
    {14.7819f,66.6667f},
    {14.7819f,0.0f}
};

static const SOG_StrokeStrip ch105st[] =
{
    {5,ch105st0},
    {2,ch105st1}
};

static const SOG_StrokeChar ch105 = {28.8638f,2,ch105st};

/* char: 0x6a */

static const SOG_StrokeVertex ch106st0[] =
{
    {17.3876f,100.0f},
    {22.1495f,95.2381f},
    {26.9114f,100.0f},
    {22.1495f,104.762f},
    {17.3876f,100.0f}
};

static const SOG_StrokeVertex ch106st1[] =
{
    {22.1495f,66.6667f},
    {22.1495f,-14.2857f},
    {17.3876f,-28.5714f},
    {7.8638f,-33.3333f},
    {-1.66f,-33.3333f}
};

static const SOG_StrokeStrip ch106st[] =
{
    {5,ch106st0},
    {5,ch106st1}
};

static const SOG_StrokeChar ch106 = {36.2314f,2,ch106st};

/* char: 0x6b */

static const SOG_StrokeVertex ch107st0[] =
{
    {9.6f,100.0f},
    {9.6f,0.0f}
};

static const SOG_StrokeVertex ch107st1[] =
{
    {57.219f,66.6667f},
    {9.6f,19.0476f}
};

static const SOG_StrokeVertex ch107st2[] =
{
    {28.6476f,38.0952f},
    {61.981f,0.0f}
};

static const SOG_StrokeStrip ch107st[] =
{
    {2,ch107st0},
    {2,ch107st1},
    {2,ch107st2}
};

static const SOG_StrokeChar ch107 = {62.521f,3,ch107st};

/* char: 0x6c */

static const SOG_StrokeVertex ch108st0[] =
{
    {10.02f,100.0f},
    {10.02f,0.0f}
};

static const SOG_StrokeStrip ch108st[] =
{
    {2,ch108st0}
};

static const SOG_StrokeChar ch108 = {19.34f,1,ch108st};

/* char: 0x6d */

static const SOG_StrokeVertex ch109st0[] =
{
    {9.6f,66.6667f},
    {9.6f,0.0f}
};

static const SOG_StrokeVertex ch109st1[] =
{
    {9.6f,47.619f},
    {23.8857f,61.9048f},
    {33.4095f,66.6667f},
    {47.6952f,66.6667f},
    {57.219f,61.9048f},
    {61.981f,47.619f},
    {61.981f,0.0f}
};

static const SOG_StrokeVertex ch109st2[] =
{
    {61.981f,47.619f},
    {76.2667f,61.9048f},
    {85.7905f,66.6667f},
    {100.076f,66.6667f},
    {109.6f,61.9048f},
    {114.362f,47.619f},
    {114.362f,0.0f}
};

static const SOG_StrokeStrip ch109st[] =
{
    {2,ch109st0},
    {7,ch109st1},
    {7,ch109st2}
};

static const SOG_StrokeChar ch109 = {123.962f,3,ch109st};

/* char: 0x6e */

static const SOG_StrokeVertex ch110st0[] =
{
    {9.18f,66.6667f},
    {9.18f,0.0f}
};

static const SOG_StrokeVertex ch110st1[] =
{
    {9.18f,47.619f},
    {23.4657f,61.9048f},
    {32.9895f,66.6667f},
    {47.2752f,66.6667f},
    {56.799f,61.9048f},
    {61.561f,47.619f},
    {61.561f,0.0f}
};

static const SOG_StrokeStrip ch110st[] =
{
    {2,ch110st0},
    {7,ch110st1}
};

static const SOG_StrokeChar ch110 = {70.881f,2,ch110st};

/* char: 0x6f */

static const SOG_StrokeVertex ch111st0[] =
{
    {28.7895f,66.6667f},
    {19.2657f,61.9048f},
    {9.7419f,52.381f},
    {4.98f,38.0952f},
    {4.98f,28.5714f},
    {9.7419f,14.2857f},
    {19.2657f,4.7619f},
    {28.7895f,0.0f},
    {43.0752f,0.0f},
    {52.599f,4.7619f},
    {62.1229f,14.2857f},
    {66.8848f,28.5714f},
    {66.8848f,38.0952f},
    {62.1229f,52.381f},
    {52.599f,61.9048f},
    {43.0752f,66.6667f},
    {28.7895f,66.6667f}
};

static const SOG_StrokeStrip ch111st[] =
{
    {17,ch111st0}
};

static const SOG_StrokeChar ch111 = {71.7448f,1,ch111st};

/* char: 0x70 */

static const SOG_StrokeVertex ch112st0[] =
{
    {9.46f,66.6667f},
    {9.46f,-33.3333f}
};

static const SOG_StrokeVertex ch112st1[] =
{
    {9.46f,52.381f},
    {18.9838f,61.9048f},
    {28.5076f,66.6667f},
    {42.7933f,66.6667f},
    {52.3171f,61.9048f},
    {61.841f,52.381f},
    {66.6029f,38.0952f},
    {66.6029f,28.5714f},
    {61.841f,14.2857f},
    {52.3171f,4.7619f},
    {42.7933f,0.0f},
    {28.5076f,0.0f},
    {18.9838f,4.7619f},
    {9.46f,14.2857f}
};

static const SOG_StrokeStrip ch112st[] =
{
    {2,ch112st0},
    {14,ch112st1}
};

static const SOG_StrokeChar ch112 = {70.8029f,2,ch112st};

/* char: 0x71 */

static const SOG_StrokeVertex ch113st0[] =
{
    {61.9829f,66.6667f},
    {61.9829f,-33.3333f}
};

static const SOG_StrokeVertex ch113st1[] =
{
    {61.9829f,52.381f},
    {52.459f,61.9048f},
    {42.9352f,66.6667f},
    {28.6495f,66.6667f},
    {19.1257f,61.9048f},
    {9.6019f,52.381f},
    {4.84f,38.0952f},
    {4.84f,28.5714f},
    {9.6019f,14.2857f},
    {19.1257f,4.7619f},
    {28.6495f,0.0f},
    {42.9352f,0.0f},
    {52.459f,4.7619f},
    {61.9829f,14.2857f}
};

static const SOG_StrokeStrip ch113st[] =
{
    {2,ch113st0},
    {14,ch113st1}
};

static const SOG_StrokeChar ch113 = {70.7429f,2,ch113st};

/* char: 0x72 */

static const SOG_StrokeVertex ch114st0[] =
{
    {9.46f,66.6667f},
    {9.46f,0.0f}
};

static const SOG_StrokeVertex ch114st1[] =
{
    {9.46f,38.0952f},
    {14.2219f,52.381f},
    {23.7457f,61.9048f},
    {33.2695f,66.6667f},
    {47.5552f,66.6667f}
};

static const SOG_StrokeStrip ch114st[] =
{
    {2,ch114st0},
    {5,ch114st1}
};

static const SOG_StrokeChar ch114 = {49.4952f,2,ch114st};

/* char: 0x73 */

static const SOG_StrokeVertex ch115st0[] =
{
    {57.081f,52.381f},
    {52.319f,61.9048f},
    {38.0333f,66.6667f},
    {23.7476f,66.6667f},
    {9.4619f,61.9048f},
    {4.7f,52.381f},
    {9.4619f,42.8571f},
    {18.9857f,38.0952f},
    {42.7952f,33.3333f},
    {52.319f,28.5714f},
    {57.081f,19.0476f},
    {57.081f,14.2857f},
    {52.319f,4.7619f},
    {38.0333f,0.0f},
    {23.7476f,0.0f},
    {9.4619f,4.7619f},
    {4.7f,14.2857f}
};

static const SOG_StrokeStrip ch115st[] =
{
    {17,ch115st0}
};

static const SOG_StrokeChar ch115 = {62.321f,1,ch115st};

/* char: 0x74 */

static const SOG_StrokeVertex ch116st0[] =
{
    {14.8257f,100.0f},
    {14.8257f,19.0476f},
    {19.5876f,4.7619f},
    {29.1114f,0.0f},
    {38.6352f,0.0f}
};

static const SOG_StrokeVertex ch116st1[] =
{
    {0.54f,66.6667f},
    {33.8733f,66.6667f}
};

static const SOG_StrokeStrip ch116st[] =
{
    {5,ch116st0},
    {2,ch116st1}
};

static const SOG_StrokeChar ch116 = {39.3152f,2,ch116st};

/* char: 0x75 */

static const SOG_StrokeVertex ch117st0[] =
{
    {9.46f,66.6667f},
    {9.46f,19.0476f},
    {14.2219f,4.7619f},
    {23.7457f,0.0f},
    {38.0314f,0.0f},
    {47.5552f,4.7619f},
    {61.841f,19.0476f}
};

static const SOG_StrokeVertex ch117st1[] =
{
    {61.841f,66.6667f},
    {61.841f,0.0f}
};

static const SOG_StrokeStrip ch117st[] =
{
    {7,ch117st0},
    {2,ch117st1}
};

static const SOG_StrokeChar ch117 = {71.161f,2,ch117st};

/* char: 0x76 */

static const SOG_StrokeVertex ch118st0[] =
{
    {1.8f,66.6667f},
    {30.3714f,0.0f}
};

static const SOG_StrokeVertex ch118st1[] =
{
    {58.9429f,66.6667f},
    {30.3714f,0.0f}
};

static const SOG_StrokeStrip ch118st[] =
{
    {2,ch118st0},
    {2,ch118st1}
};

static const SOG_StrokeChar ch118 = {60.6029f,2,ch118st};

/* char: 0x77 */

static const SOG_StrokeVertex ch119st0[] =
{
    {2.5f,66.6667f},
    {21.5476f,0.0f}
};

static const SOG_StrokeVertex ch119st1[] =
{
    {40.5952f,66.6667f},
    {21.5476f,0.0f}
};

static const SOG_StrokeVertex ch119st2[] =
{
    {40.5952f,66.6667f},
    {59.6429f,0.0f}
};

static const SOG_StrokeVertex ch119st3[] =
{
    {78.6905f,66.6667f},
    {59.6429f,0.0f}
};

static const SOG_StrokeStrip ch119st[] =
{
    {2,ch119st0},
    {2,ch119st1},
    {2,ch119st2},
    {2,ch119st3}
};

static const SOG_StrokeChar ch119 = {80.4905f,4,ch119st};

/* char: 0x78 */

static const SOG_StrokeVertex ch120st0[] =
{
    {1.66f,66.6667f},
    {54.041f,0.0f}
};

static const SOG_StrokeVertex ch120st1[] =
{
    {54.041f,66.6667f},
    {1.66f,0.0f}
};

static const SOG_StrokeStrip ch120st[] =
{
    {2,ch120st0},
    {2,ch120st1}
};

static const SOG_StrokeChar ch120 = {56.401f,2,ch120st};

/* char: 0x79 */

static const SOG_StrokeVertex ch121st0[] =
{
    {6.5619f,66.6667f},
    {35.1333f,0.0f}
};

static const SOG_StrokeVertex ch121st1[] =
{
    {63.7048f,66.6667f},
    {35.1333f,0.0f},
    {25.6095f,-19.0476f},
    {16.0857f,-28.5714f},
    {6.5619f,-33.3333f},
    {1.8f,-33.3333f}
};

static const SOG_StrokeStrip ch121st[] =
{
    {2,ch121st0},
    {6,ch121st1}
};

static const SOG_StrokeChar ch121 = {66.0648f,2,ch121st};

/* char: 0x7a */

static const SOG_StrokeVertex ch122st0[] =
{
    {56.821f,66.6667f},
    {4.44f,0.0f}
};

static const SOG_StrokeVertex ch122st1[] =
{
    {4.44f,66.6667f},
    {56.821f,66.6667f}
};

static const SOG_StrokeVertex ch122st2[] =
{
    {4.44f,0.0f},
    {56.821f,0.0f}
};

static const SOG_StrokeStrip ch122st[] =
{
    {2,ch122st0},
    {2,ch122st1},
    {2,ch122st2}
};

static const SOG_StrokeChar ch122 = {61.821f,3,ch122st};

/* char: 0x7b */

static const SOG_StrokeVertex ch123st0[] =
{
    {31.1895f,119.048f},
    {21.6657f,114.286f},
    {16.9038f,109.524f},
    {12.1419f,100.0f},
    {12.1419f,90.4762f},
    {16.9038f,80.9524f},
    {21.6657f,76.1905f},
    {26.4276f,66.6667f},
    {26.4276f,57.1429f},
    {16.9038f,47.619f}
};

static const SOG_StrokeVertex ch123st1[] =
{
    {21.6657f,114.286f},
    {16.9038f,104.762f},
    {16.9038f,95.2381f},
    {21.6657f,85.7143f},
    {26.4276f,80.9524f},
    {31.1895f,71.4286f},
    {31.1895f,61.9048f},
    {26.4276f,52.381f},
    {7.38f,42.8571f},
    {26.4276f,33.3333f},
    {31.1895f,23.8095f},
    {31.1895f,14.2857f},
    {26.4276f,4.7619f},
    {21.6657f,0.0f},
    {16.9038f,-9.5238f},
    {16.9038f,-19.0476f},
    {21.6657f,-28.5714f}
};

static const SOG_StrokeVertex ch123st2[] =
{
    {16.9038f,38.0952f},
    {26.4276f,28.5714f},
    {26.4276f,19.0476f},
    {21.6657f,9.5238f},
    {16.9038f,4.7619f},
    {12.1419f,-4.7619f},
    {12.1419f,-14.2857f},
    {16.9038f,-23.8095f},
    {21.6657f,-28.5714f},
    {31.1895f,-33.3333f}
};

static const SOG_StrokeStrip ch123st[] =
{
    {10,ch123st0},
    {17,ch123st1},
    {10,ch123st2}
};

static const SOG_StrokeChar ch123 = {41.6295f,3,ch123st};

/* char: 0x7c */

static const SOG_StrokeVertex ch124st0[] =
{
    {11.54f,119.048f},
    {11.54f,-33.3333f}
};

static const SOG_StrokeStrip ch124st[] =
{
    {2,ch124st0}
};

static const SOG_StrokeChar ch124 = {23.78f,1,ch124st};

/* char: 0x7d */

static const SOG_StrokeVertex ch125st0[] =
{
    {9.18f,119.048f},
    {18.7038f,114.286f},
    {23.4657f,109.524f},
    {28.2276f,100.0f},
    {28.2276f,90.4762f},
    {23.4657f,80.9524f},
    {18.7038f,76.1905f},
    {13.9419f,66.6667f},
    {13.9419f,57.1429f},
    {23.4657f,47.619f}
};

static const SOG_StrokeVertex ch125st1[] =
{
    {18.7038f,114.286f},
    {23.4657f,104.762f},
    {23.4657f,95.2381f},
    {18.7038f,85.7143f},
    {13.9419f,80.9524f},
    {9.18f,71.4286f},
    {9.18f,61.9048f},
    {13.9419f,52.381f},
    {32.9895f,42.8571f},
    {13.9419f,33.3333f},
    {9.18f,23.8095f},
    {9.18f,14.2857f},
    {13.9419f,4.7619f},
    {18.7038f,0.0f},
    {23.4657f,-9.5238f},
    {23.4657f,-19.0476f},
    {18.7038f,-28.5714f}
};

static const SOG_StrokeVertex ch125st2[] =
{
    {23.4657f,38.0952f},
    {13.9419f,28.5714f},
    {13.9419f,19.0476f},
    {18.7038f,9.5238f},
    {23.4657f,4.7619f},
    {28.2276f,-4.7619f},
    {28.2276f,-14.2857f},
    {23.4657f,-23.8095f},
    {18.7038f,-28.5714f},
    {9.18f,-33.3333f}
};

static const SOG_StrokeStrip ch125st[] =
{
    {10,ch125st0},
    {17,ch125st1},
    {10,ch125st2}
};

static const SOG_StrokeChar ch125 = {41.4695f,3,ch125st};

/* char: 0x7e */

static const SOG_StrokeVertex ch126st0[] =
{
    {2.92f,28.5714f},
    {2.92f,38.0952f},
    {7.6819f,52.381f},
    {17.2057f,57.1429f},
    {26.7295f,57.1429f},
    {36.2533f,52.381f},
    {55.301f,38.0952f},
    {64.8248f,33.3333f},
    {74.3486f,33.3333f},
    {83.8724f,38.0952f},
    {88.6343f,47.619f}
};

static const SOG_StrokeVertex ch126st1[] =
{
    {2.92f,38.0952f},
    {7.6819f,47.619f},
    {17.2057f,52.381f},
    {26.7295f,52.381f},
    {36.2533f,47.619f},
    {55.301f,33.3333f},
    {64.8248f,28.5714f},
    {74.3486f,28.5714f},
    {83.8724f,33.3333f},
    {88.6343f,47.619f},
    {88.6343f,57.1429f}
};

static const SOG_StrokeStrip ch126st[] =
{
    {11,ch126st0},
    {11,ch126st1}
};

static const SOG_StrokeChar ch126 = {91.2743f,2,ch126st};

/* char: 0x7f */

static const SOG_StrokeVertex ch127st0[] =
{
    {52.381f,100.0f},
    {14.2857f,-33.3333f}
};

static const SOG_StrokeVertex ch127st1[] =
{
    {28.5714f,66.6667f},
    {14.2857f,61.9048f},
    {4.7619f,52.381f},
    {0.0f,38.0952f},
    {0.0f,23.8095f},
    {4.7619f,14.2857f},
    {14.2857f,4.7619f},
    {28.5714f,0.0f},
    {38.0952f,0.0f},
    {52.381f,4.7619f},
    {61.9048f,14.2857f},
    {66.6667f,28.5714f},
    {66.6667f,42.8571f},
    {61.9048f,52.381f},
    {52.381f,61.9048f},
    {38.0952f,66.6667f},
    {28.5714f,66.6667f}
};

static const SOG_StrokeStrip ch127st[] =
{
    {2,ch127st0},
    {17,ch127st1}
};

static const SOG_StrokeChar ch127 = {66.6667f,2,ch127st};

static const SOG_StrokeChar *chars[] =
{
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    &ch32, &ch33, &ch34, &ch35, &ch36, &ch37, &ch38, &ch39,
    &ch40, &ch41, &ch42, &ch43, &ch44, &ch45, &ch46, &ch47,
    &ch48, &ch49, &ch50, &ch51, &ch52, &ch53, &ch54, &ch55,
    &ch56, &ch57, &ch58, &ch59, &ch60, &ch61, &ch62, &ch63,
    &ch64, &ch65, &ch66, &ch67, &ch68, &ch69, &ch70, &ch71,
    &ch72, &ch73, &ch74, &ch75, &ch76, &ch77, &ch78, &ch79,
    &ch80, &ch81, &ch82, &ch83, &ch84, &ch85, &ch86, &ch87,
    &ch88, &ch89, &ch90, &ch91, &ch92, &ch93, &ch94, &ch95,
    &ch96, &ch97, &ch98, &ch99, &ch100, &ch101, &ch102, &ch103,
    &ch104, &ch105, &ch106, &ch107, &ch108, &ch109, &ch110, &ch111,
    &ch112, &ch113, &ch114, &ch115, &ch116, &ch117, &ch118, &ch119,
    &ch120, &ch121, &ch122, &ch123, &ch124, &ch125, &ch126, &ch127
};

const SOG_StrokeFont ogStrokeRoman = {(char *)"Roman",128,152.381f,chars};

/*! parts of og_font.c
    \file  og_font.c
    \brief Bitmap and stroke fonts
*/

/*
 * Portions copyright 2003, OpenGLUT contributors.
 * OpenGLUT branched from freeglut in February 2004.
 */

/* -- PRIVATE FUNCTIONS ---------------------------------------------------- */

/*!
    Matches a font ID with a SOG_StrokeFont structure pointer.
    This was changed to match the GLUT header style.
*/
static SOG_StrokeFont *oghStrokeByID( void *font )
{
    if( font == GLUT_STROKE_ROMAN      )
        return (SOG_StrokeFont *) &ogStrokeRoman;

    return 0;
}


/* -- INTERFACE FUNCTIONS -------------------------------------------------- */

/*!
    \fn
    \brief    Draw a stroked character.
    \ingroup  fonts
    \param    fontID    A GLUT stroked font identifier.
    \param    character An ASCII character other than NUL.

              This function draws one \a character from one stroked font
              (selected by \a fontID)
              using OpenGL \a GL_LINE_STRIP.  These characters
              are drawn at the origin in model space.
              The the model space origin is translated at the end,
              according to the \a character width in \a fontID.

              Does nothing if:
               - The \a fontID is invalid.
               - The \a character is out of the font's range.

    \see      glBegin(), glTranslatef(), glutStrokeWidth(), glutStrokeString(),
              glutStrokeHeight(), glutBitmapCharacter()
*/
void glutStrokeCharacter( void *fontID, int character )
{
    const SOG_StrokeChar *schar;
    const SOG_StrokeStrip *strip;
    int i, j;
    SOG_StrokeFont *font = oghStrokeByID( fontID );

    if( !font ||
        ( 1 > character ) ||
        ( font->Quantity < character ) )
        return;

    schar = font->Characters[ character ];
    if( schar )
    {
        strip = schar->Strips;

        for( i = 0; i < schar->Number; i++, strip++ )
        {
            glBegin( GL_LINE_STRIP );
            for( j = 0; j < strip->Number; j++ )
                glVertex2f( strip->Vertices[ j ].X, strip->Vertices[ j ].Y );
            glEnd( );
        }
        glTranslatef( schar->Right, 0.0, 0.0 );
    }
}

/*!
    \fn
    \brief    Draw a string of stroked characters.
    \ingroup  fonts
    \param    fontID    A GLUT stroked font identifier.
    \param    string    A NUL-terminated ASCII string.

              This function draws a \a string in the font indicated
              by \a fontID.
              It is <i>almost</i> equivalent to calling glutStrokeCharacter()
              on each character in the \a string, successively.
              Mostly, it is a convenience function to hide the loop,
              and to treat \\n as a special symbol rather than a normal
              glyph.

              The first character displays at the current model space
              origin,  The origin changes by successive translations.

              The newline character, \\n (ASCII LF) is treated as
              a newline and resets the origin horizontally
              while advancing the line 1 font-height down the y-axis.

              Does nothing if:
               - \a fontID is out of range.
               - \a string is \a NULL
               - \a string is empty

              Unlike glutBitmapString(), there is little performance
              advantage to using glutStrokeString() as compared with
              calling glutStrokeCharacter() yourself for every
              character.

    \see      glutStrokeLength(), glutStrokeCharacter(),
              glutStrokeHeight(), glutBitmapString()
*/
void glutStrokeString( void *fontID, const unsigned char *string )
{
    int i, j;
    float length = 0.0;
    SOG_StrokeFont *font = oghStrokeByID( fontID );
    unsigned char c;

    if( font && string )
        /*
         * Step through the string, drawing each character.
         * A newline will simply translate the next character's insertion
         * point back to the start of the line and down one line.
         */
        while( (c = *string++) )
        {
            if( c < font->Quantity ) 
            {
                if( c == '\n' )
                {
                    glTranslatef ( -length, -( float )( font->Height ), 0.0 );
                    length = 0.0;
                }
                else  /* Not an EOL, draw the bitmap character */
                {
                    const SOG_StrokeChar *schar =
                        font->Characters[ c ];
                    if( schar )
                    {
                        const SOG_StrokeStrip *strip = schar->Strips;

                        for( i = 0; i < schar->Number; i++, strip++ )
                        {
                            glBegin( GL_LINE_STRIP );
                            for( j = 0; j < strip->Number; j++ )
                                glVertex2f( strip->Vertices[ j ].X,
                                            strip->Vertices[ j ].Y);

                            glEnd( );
                        }

                        length += schar->Right;
                        glTranslatef( schar->Right, 0.0, 0.0 );
                    }
                }
            }
        }
}

/*!
    \fn
    \brief    Returns the width in pixels of a character in a given font.
    \ingroup  fonts
    \param    fontID    A GLUT stroked font identifier.
    \param    character A character code.

              This function reports how far the model space origin will advance
              if you putput this \a character in the font named by \a fontID.
              Not all letters will use their full width, especially in
              fixed-width fonts.

              Returns 0 if \a character is out of range or if the
              \a fontID is invalid.

    \todo     Determine if any glyphs are either wider than this
              function or if they render outside of the bounding
              box given by
              <i>(0,-descent)</i> by <i>(width,height-descent)</i>.
    \note     Historically, this function has been described as
              returning a pixel-width, but was implemented to
              return the width in model-space units, rounded to integers.
              GLUT never resolved this, and freeglut duplicated the
              confusion.
              OpenGLUT has decided to stay in model-space and to
              return the unrounded floating point value.
              An unreleased GLUT 3.8 was supposed to include
              glutStrokeWidthf() and glutStrokeLengthf() (note
              the *f suffixes), but that is not in wide use.
    \see      glutStrokeCharacter(), glutStrokeLength(), glutStrokeHeight()
              glutBitmapWidth()
*/
float glutStrokeWidth( void *fontID, int character )
{
    float ret = 0;
    SOG_StrokeFont *font = oghStrokeByID( fontID );

    if( font &&
        ( 0 < character ) &&
        ( font->Quantity > character ) )
    {
        const SOG_StrokeChar *schar = font->Characters[ character ];
        if( schar )
            ret = schar->Right;
    }

    return ret;
}

/*!
    \fn
    \brief    Returns model space width of a string in a given font.
    \ingroup  fonts
    \param    fontID    A GLUT stroked font identifier.
    \param    string    A C-style (NUL-terminated) string.

              This function reports the sum of the widths of the
              characters in a \a string, using the font metrics of
              a given \a font.

              Like glutStrokeString(), glutStrokeLength() respects
              newlines in the input.

              Returns 0 if:
               - The \a fontID is out of range.
               - The \a string is \a NULL.
               - All characters in the \a string are zero-width.

    \note     Refer to glutStrokeWidth() for notes on the
              nature of this function's return value, and for
              comparisons to old GLUT and freeglut.
    \see      glutStrokeString(), glutStrokeWidth(), glutStrokeHeight(),
              glutBitmapLength()
*/
float glutStrokeLength( void *fontID, const unsigned char *string )
{
    unsigned char c;
    float length = 0.0;
    float this_line_length = 0.0;
    SOG_StrokeFont *font = oghStrokeByID( fontID );

    if( font && string ) 
    {
        while( (c = *string++) )
        {
            if( c < font->Quantity )
            {
                if( c == '\n' )
                {
                    if( length < this_line_length )
                        length = this_line_length;
                    this_line_length = 0.0;
                }
                else  /* Not an EOL, increment the length of this line */
                {
                    const SOG_StrokeChar *schar =
                        font->Characters[ c ];
                    if( schar )
                        this_line_length += schar->Right;
                }
            }
        }
    }

    if( length < this_line_length )
        length = this_line_length;
    return length;
}

/*!
    \fn
    \brief    Returns the height of a given font.
    \ingroup  fonts
    \param    fontID    A GLUT stroked font identifier.

              This function reports the height of a font,
              given by \a fontID,
              as a global characteristic of that font.

              Returns 0 if \a fontID is invalid.

    \note     Does <i>not</i> report the height used by individual
              characters.  This may limit its usefulness; perhaps we
              should change it?  (And/or add a new function.)
    \todo     We have discussed adding a "font descender" query.
              We should go ahead and do it.
    \see      glutStrokeCharacter(), glutStrokeString(), glutStrokeWidth(),
              glutStrokeLength(), glutBitmapHeight()
*/
GLfloat glutStrokeHeight( void *fontID )
{
    GLfloat ret = 0;
    SOG_StrokeFont *font = oghStrokeByID( fontID );

    if( font )
        ret = font->Height;

    return ret;
}
